/**
 * 
 */
var mX=0,mY=0;

var statementsTopBorder;

var primes=[];
var exclColors=[];
var maxColorSlctd=-1;
var n=80;
var canvas;
var cntx;

var tapping=false;

function initialise(){
	initialiseExcludingColors();
	simulating=false;
	
	showAppTitle();
	showButtonCaptions();
	showProblem();
	adjustCode();
	placeContents();
	showSimulationValues(); //καλείται για να αποκρύψει όλα τα span elements
	initialiseGraphics();
	initialiseEvents();
	showPrompt();
	setParameterValue(0,10);
	$(".varLabel").css("text-align","center");
}

function initialiseEvents(){

    $(".toChange").focus(function(){
        if(simulating){
            $("#"+this.id).blur();
        }
    });
    
    //Χρωματική αντιστοιχία ελεύθερου κειμένου και ψευδογλώσσας
    $(".algoStep").hover(
        function(){
            if(enableRepresentationMatching){
                var index=parseInt(this.id.substr(4,1));
                if(index<6) $("#"+this.id).addClass("matched");
                showMatches(index);
            }
        },
        function(){
            $(".matched").removeClass("matched");
        }
    );
    
    
    $(".algoStep").on("tap",function(){
        $(".matched").removeClass("matched");
        if(enableRepresentationMatching){
            var index=parseInt(this.id.substr(4,1));
            if(index<6) $("#"+this.id).addClass("matched");
            showMatches(index);
        }        
    });
    
    document.addEventListener("touchend",function(evt){
        if(tapping){
            tapping=false;
            $(".matched").removeClass("matched");
            evt.preventDefault();
            return;
        }
    });
    
	$("#clearBreakPoints").on("click touchend",function(){
	    $(".breakPointCmd").removeClass("breakPointCmd");
	});
	
	$("#visualisation").on("mousemove touchend",function(evt){
		var rect = canvas.getBoundingClientRect();
		mX=evt.clientX-rect.left;
	    mY=evt.clientY-rect.top;
		handleMouseMove();
	});
	
	$(".algoCmd").on("click touchend",function(evt){
	    if(evt.target.id.substr(0,7)=="usrEntr") return;
		if($("#"+this.id).hasClass("breakPointCmd")){
			$("#"+this.id).removeClass("breakPointCmd");
		}
		else{
			$("#"+this.id).addClass("breakPointCmd");
		}
	});

	//touch events
	$("#showInfo").on("touchend",function(evt){
	    $("#showInfo").trigger("click");
	});
	
	//Κουμπιά διαχείρισης ορατού τμήματος πίνακα
	$("#btnFirst").on("click touchstart",function(evt){
		evt.preventDefault();
		handleArray(-firstVisibleCell+1);
	});

	$("#btnPrevious").on("click touchstart",function(evt){
		evt.preventDefault();
		handleArray(-0.5);
	});

	$("#btnNext").on("click touchstart",function(evt){
		evt.preventDefault();
		handleArray(0.5);
	});

	$("#btnLast").on("click touchstart",function(evt){
		evt.preventDefault();
		handleArray(n-firstVisibleCell);
	});

	//Κουμπιά διαχείρισης εφαρμογής
    $("#slideSpeed").bind("change keyup touchend",function(event,ui) {
        var maxSimSpeed=Number($(this).attr("max"))+1;
        simSpeed=maxSimSpeed-$(this).val();
    });
	
    $("#showCaptions").bind("change keyup touchend",function(event,ui) {
    	if($("#showCaptions:checked").val()=="show"){
    		buttonCaptionsVisible=true;
    	}
    	else{
    		buttonCaptionsVisible=false;
    	}
    	showButtonCaptions();
    });
    
    
    $("#showVarValues").bind("change keyup touchend",function(event,ui) {
    	if($("#showVarValues:checked").val()=="show"){
    		showVarValues=true;
    	}
    	else{
    		showVarValues=false;
    	}
    });
    
    $("#showComments").bind("change keyup touchend",function(event,ui) {
    	if($("#showComments:checked").val()=="show"){
    		$("#commentArea").slideDown("slow");
    		showComments=true;
    	}
    	else{
    		$("#commentArea").slideUp("slow");
    		showComments=false;
    	}
    });
	
    $("#requestConfirmations").bind("change keyup touchend",function(event,ui) {
    	if($("#requestConfirmations:checked").val()=="reqConfirm"){
    		requestConfirmationState=requestConfirmation;
    	}
    	else{
    		requestConfirmationState=dontRequestConfirmation;
    	}
    });
    
    $("#matchRepresentations").bind("change keyup touchend",function(event,ui) {
        if($("#matchRepresentations:checked").val()=="reqRepresentations"){
            enableRepresentationMatching=true;
        }
        else{
            enableRepresentationMatching=false;
        }
    });
    
    $("#showFullSimulationPath").bind("change keyup touchend",function(event,ui) {
    	if($("#showFullSimulationPath:checked").val()=="showFullSimPath"){
    		hideSimulationPath=false;
    	}
    	else{
    		hideSimulationPath=true;
    	}
    });

    $("#btnPlay").on("click touchstart",function(){
    	$("#showOptions").hide();
    	simulating=true;
    	$("#btnPlay").hide();
    	$("#btnStop").show();
    	$("#btnPause").prop("disabled",false);
    	$("#btnForward").prop("disabled",true);
		//resetSimulation(); //Η εντολή απενεργοποιείται για να είναι δυνατή η αυτόματη εκτέλεση από εκεί που σταμάτησε η βηματική
    	promptID=promptDuringRunning;
    	simulationAborted=false;
    	simulateCode(true);
    });
    
    $("#btnStop").on("click touchstart",function(){
    	simulating=false;
    	simulateCode(false);
    	resetSimulation();
    	$("#btnPlay").show();
    	$("#btnStop").hide();
    	$("#btnPause").show();
    	$("#btnContinue").hide();
    	$("#btnForward").show();
    	if(simulationAborted){
    	    promptID=promptToFillInBlanks;
    	}
    	else{
    	    promptID=promptToRunCode;
    	}
    	showPrompt();
    });
    
    $("#btnPause").on("click touchstart",function(){
    	$("#showOptions").show();
    	simulating=false;
    	$("#btnPause").hide();
    	$("#btnContinue").show();
    	clearInterval(timerLoop);
    	handleContinuationButtons();
    	showPrompt();
    });
    
    $("#btnContinue").on("click touchstart",function(){
    	$("#showOptions").hide();
    	simulating=true;
    	$("#btnContinue").hide();
    	$("#btnForward").prop("disabled",true);
    	$("#btnPause").show();
    	simulateCode(true);
    });
                
    $("#btnForward").on("click touchstart",function(){
        simulationAborted=false;
    	if(simulationIndex==-1){
    		resetSimulation();
    	}
    	if(simulationIndex<=parseInt(while1End.substr(3,2))){
    		simulateRun();
    	}
    });
    
    $("#btnCheckCode").on("click touchstart",function(){
    	checkCode();
    	handleContinuationButtons();
    });

    $("#btnShowSolution").on("click touchstart",function(){
    	showSolution();
    });
    
    $("#btnInitialiseCode").on("click touchstart",function(){
    	if(requestConfirmationState || confirm("ΠΡΟΣΟΧΗ! Η εντολή αυτή θα επαναφέρει τις αρχικές καταχωρήσεις και θα διαγράψει όλα τα Σημεία Διακοπής. Είσαι σίγουρος;")){
        	$(".breakPointCmd").removeClass("breakPointCmd");
        	simulating=false;
        	resetSimulation();
        	handleContinuationButtons();
        	var code;
        	for(var i=0;i<noOfEntries;i++){
        		code="ˍˍˍ";
        		if(userEntries[i]!=null && userEntries[i]!=""){
        			code=userEntries[i];
        		}
        		$("#usrEntr"+i).html(code);
        	}
        	countEntries();
    	}
    });

    $("#btnEnter").on("click touchstart",function(){
		if(simulating)timerLoop=setInterval(function(){simulateRun();},simSpeed);
    });
    
    $("#number-A").on("touchstart",function(){
    	$("#number-A").focus();
    });

    $("#number-A").bind("keyup mouseup",function(){
    	var newValue=parseInt($("#number-A").val());
    	if(newValue>=parseInt($("#number-A").attr("min")) && newValue<=parseInt($("#number-A").attr("max"))){
    		setParameterValue(0,newValue);
    	}
    	else{
    		setParameterValue(0,varValues[0]);
    	}
    	abortSimulation();
    	resetSimulation();
    	handleContinuationButtons();
    });

    $(".cellNavigation").mouseover(function(){
    	if($(this).css("opacity")>0){
      	  $("#"+this.id).fadeTo(0,1);
    	  $("#"+this.id).css({
    		  "background-color" : "#c0c0c0",
    		  "box-shadow" : "1px 1px 2px #000000,2px 2px 4px #505050,3px 3px 6px #a0a0a0"
    	  });
    	}
    });
    
    $(".cellNavigation").mouseout(function(){
    	if($(this).css("opacity")>0){
        	$(this).fadeTo(0,0.5);
        	$(this).css({
        		"background-color" : "#ffffff",
        		"box-shadow" : "1px 1px #ffffff,2px 2px #ffffff,3px 3px #ffffff"
        	});
    	}
    });
}

function setParameterValue(paramIndex,newValue){
	$("#number-"+String.fromCharCode(65+paramIndex)).val(newValue);
	varValues[paramIndex]=newValue;
	if(paramIndex==0){
		n=newValue;
		resizeArray();
	}
}

function handleMouseDown(){
}

function handleMouseUp(){
}

function handleMouseMove(){
	var slctdNo=-1;
	if(mY>=cellTop && mY<=cellTop+cellSize){
		slctdNo=parseInt((mX-cellSize/2)/cellSize+firstVisibleCell);
		var msg="";
		var slctNoInfo="";
		if(slctdNo>1){
			if(primes[slctdNo]==-1){
				msg="Για να δείτε αποτελέσματα πρέπει πρώτα να εκτελεστεί ο αλγόριθμος.";
			}
			else{
				if(slctdNo>1 && slctdNo<primes.length){
					slctNoInfo=getNoInfo(slctdNo);
					msg=slctdNo+": "+slctNoInfo;
				}
			}
		}
		drawArray(firstVisibleCell);
		if(slctNoInfo.substr(0,1)=="Π"){
			cntx.fillStyle="#0000ff";
		}
		else{
			cntx.fillStyle="#ff0000";
		}
		cntx.font="14px Arial";
		var xCoord=Math.min(mX,0.99*canvas.width-cntx.measureText(msg).width);
		cntx.fillText(msg,xCoord,0.97*canvas.height); 
	}
	if(debugMode) document.getElementById("debug").innerHTML="mX="+mX+" mY="+mY+" promptID="+promptID+" , "+slctdNo;
}

function handleMouseOut(){
}

function placeContents(){
	codeLeftBorder=$(document).width()/2;
	codeTopBorder=$("#buttonArea").outerHeight();
	drawTopBorder=codeTopBorder+$("#problemWording").outerHeight()+verticalBorder;
	promptTopBorder=drawTopBorder+$("#drawArea").outerHeight()+verticalBorder;
	commentTopBorder=codeTopBorder+$("#algorithmStart").outerHeight()+1.5*verticalBorder;
	
	//$("#problemTitle").css({left: 0, top: codeTopBorder});
	//$("#problemWording").css({left: $("#problemTitle").position().left+$("#problemTitle").outerHeight(), top: codeTopBorder});
	$("#problemWording").css({left: horizontalBorder, top: codeTopBorder});
	//$("#algorithmTitle").css({left: $("#problemWording").position().left+$("#problemWording").width(), top: codeTopBorder});
	$("#algorithmStart").css({left: codeLeftBorder, top: codeTopBorder});
	$("#commentArea").css({left: codeLeftBorder, top: commentTopBorder, width: $("#algorithmStart").width(), height: 40});
	$("#drawArea").css({top: drawTopBorder});
	$("#promptArea").css({top: promptTopBorder});
}

function adjustCode(){
	var j=-1;
	var html="<code class='algorithm'>";
    html+='\n<span class="algoCmd" id="cmd0"><span class="reservedWord">ΓΡΑΨΕ</span> "Δώσε έναν ακέραιο στο διάστημα [2 , 300]:"</span>';
    html+="\n<span class='algoCmd' id='cmd1'><span class='reservedWord'>ΔΙΑΒΑΣΕ</span> n</span>   <span class='showValues' id='nVal'></span>";
    j++;
    html+="\n<span class='algoCmd' id='cmd2'><span class='reservedWord'>ΓΙΑ</span> i <span class='reservedWord'>ΑΠΟ</span> "+generateEntryPlaceholder("usrEntr"+j,userEntries[j],editableState)+" <span class='reservedWord'>ΜΕΧΡΙ</span> n</span>   <span class='showValues' id='iVal'></span>";
    html+="\n<span class='algoCmd' id='cmd3'>  Λ[i] <- <span class='reservedWord'>ΑΛΗΘΗΣ</span></span>";
    html+="\n<span class='algoCmd' id='cmd4'><span class='reservedWord'>ΤΕΛΟΣ_ΕΠΑΝΑΛΗΨΗΣ</span></span>";
    j++;
    html+="\n<span class='algoCmd' id='cmd5'>p <- "+generateEntryPlaceholder("usrEntr"+j,userEntries[j],editableState)+"</span>   <span class='showValues' id='pInitVal'></span>";
    j++;
    html+="\n<span class='algoCmd' id='cmd6'><span class='reservedWord'>ΟΣΟ</span> "+generateEntryPlaceholder("usrEntr"+j,userEntries[j],editableState)+" <span class='reservedWord'>ΕΠΑΝΑΛΑΒΕ</span></span>   <span class='showValues' id='while1CondVal'></span>";
    j++;
    html+="\n<span class='algoCmd' id='cmd7'>  z <- "+generateEntryPlaceholder("usrEntr"+j,userEntries[j],editableState)+" </span>   <span class='showValues' id='zInitVal'></span>";
    j++;
    html+="\n<span class='algoCmd' id='cmd8'>  <span class='reservedWord'>ΟΣΟ</span> "+generateEntryPlaceholder("usrEntr"+j,userEntries[j],editableState)+" <span class='reservedWord'>ΕΠΑΝΑΛΑΒΕ</span></span>   <span class='showValues' id='while2CondVal'></span>";
    html+="\n<span class='algoCmd' id='cmd9'>    Λ[z * p] <- <span class='reservedWord'>ΨΕΥΔΗΣ</span></span>   <span class='showValues' id='pzVal'></span>";
    j++;
    html+="\n<span class='algoCmd' id='cmd10'>    z <- z + "+generateEntryPlaceholder("usrEntr"+j,userEntries[j],editableState)+"</span>   <span class='showValues' id='zVal'></span>";
    html+="\n<span class='algoCmd' id='cmd11'>  <span class='reservedWord'>ΤΕΛΟΣ_ΕΠΑΝΑΛΗΨΗΣ</span></span>";
    html+="\n<span class='algoCmd' id='cmd12'>  <span class='reservedWord'>ΑΡΧΗ_ΕΠΑΝΑΛΗΨΗΣ</span></span>";
    j++;
    html+="\n<span class='algoCmd' id='cmd13'>    p <- p + "+generateEntryPlaceholder("usrEntr"+j,userEntries[j],editableState)+"</span>   <span class='showValues' id='pVal'></span>";
    j++;
    html+="\n<span class='algoCmd' id='cmd14'>  <span class='reservedWord'>ΜΕΧΡΙΣ_ΟΤΟΥ</span> "+generateEntryPlaceholder("usrEntr"+j,userEntries[j],editableState)+"</span>   <span class='showValues' id='repeatCondVal'></span>";
    html+="\n<span class='algoCmd' id='cmd15'><span class='reservedWord'>ΤΕΛΟΣ_ΕΠΑΝΑΛΗΨΗΣ</span></span>";
    html+="</code>";
	$("#algorithmStart").html(html);

	//Προσθήκη event παρακολούθησης εισόδου χρήστη σε κάθε editable τμήμα
    for(var i=0;i<noOfEntries;i++){
    	if(document.getElementById("usrEntr"+i)){
            document.getElementById("usrEntr"+i).addEventListener("input", function() {
        	    saveUserEntry(this.id);
        	}, false);
    	}
    }    	
}

function adjustCodeFULL(){
	var html="<code class='algorithm'>";
    html+='\n<span id="cmd0">ΓΡΑΨΕ "Δώσε έναν ακέραιο στο διάστημα [2 , 300]:"</span>';
    html+="\n<span id='cmd1'>ΔΙΑΒΑΣΕ n</span>   <span class='showValues' id='nVal'></span>";
    html+="\n<span id='cmd2'>ΓΙΑ i ΑΠΟ 2 ΜΕΧΡΙ n</span>   <span class='showValues' id='iVal'></span>";
    html+="\n<span id='cmd3'>  ΠΑ[i] <- ΑΛΗΘΗΣ</span>";
    html+="\n<span id='cmd4'>ΤΕΛΟΣ_ΕΠΑΝΑΛΗΨΗΣ</span>";
    html+="\n<span id='cmd5'>p <- 2</span>   <span class='showValues' id='pInitVal'></span>";
    html+="\n<span id='cmd6'>ΟΣΟ p^2 <= n ΕΠΑΝΑΛΑΒΕ</span>   <span class='showValues' id='while1CondVal'></span>";
    html+="\n<span id='cmd7'>  z <- 2 </span>   <span class='showValues' id='zInitVal'></span>";
    html+="\n<span id='cmd8'>  ΟΣΟ z * p <= n ΕΠΑΝΑΛΑΒΕ</span>   <span class='showValues' id='while2CondVal'></span>";
    html+="\n<span id='cmd9'>    ΠΑ[z * p] <- ΨΕΥΔΗΣ</span>   <span class='showValues' id='pzVal'></span>";
    html+="\n<span id='cmd10'>    z <- z + 1</span>   <span class='showValues' id='zVal'></span>";
    html+="\n<span id='cmd11'>  ΤΕΛΟΣ_ΕΠΑΝΑΛΗΨΗΣ</span>";
    html+="\n<span id='cmd12'>  ΑΡΧΗ_ΕΠΑΝΑΛΗΨΗΣ</span>";
    html+="\n<span id='cmd13'>    p <- p + 1</span>   <span class='showValues' id='pVal'></span>";
    html+="\n<span id='cmd14'>  ΜΕΧΡΙΣ_ΟΤΟΥ ΠΑ[p] = ΑΛΗΘΗΣ Ή p = n</span>   <span class='showValues' id='repeatCondVal'></span>";
    html+="\n<span id='cmd15'>ΤΕΛΟΣ_ΕΠΑΝΑΛΗΨΗΣ</span>";
    html+="</code>";
	$("#algorithmStart").html(html);
}


function showProblem(){
	$("#problemWording").css({left: 0, top: codeTopBorder});
	$("#problemWording").html(getProblemWording());
}

function getProblemWording(){
	var html="Το Κόσκινο του Ερατοσθένη είναι ένας αλγόριθμος για την εύρεση όλων των πρώτων αριθμών (ΠΑ) που είναι μικρότεροι ή ίσοι από έναν ακέραιο <i>n</i>.";
	html+="<br>Τα βήματα του αλγόριθμου έχουν ως εξής:";
	html+="<p class='algoStep' id='step1'><b>1.</b> Δημιουργούμε μια λίστα <span class='suggestedName'>Λ</span> από διαδοχικούς ακέραιους από το 2 μέχρι το n (δηλ. τους ακέραιους 2, 3, 4, ..., <span class='suggestedName'>n</span>).</p>";
	html+="<p class='algoStep' id='step2'><b>2.</b> Θέτουμε <span class='suggestedName'>p</span> ίσο με 2, δηλ. τον πρώτο ΠΑ της λίστας.</p>";
	html+="<p class='algoStep' id='step3'><b>3.</b> Διαγράφουμε από τη λίστα όλες τις τιμές της μορφής <span class='suggestedName'>z</span><b><sup> . </sup></b>p που είναι μικρότερες ή ίσες με n (όπου z = 2 , 3 , 4 , ...).</p>";
	html+="<p class='algoStep' id='step4'><b>4.</b> Αναζητούμε το επόμενο αριθμό, μετά τον p, που δεν έχει διαγραφεί από τη λίστα (αυτός ο αριθμός είναι ο επόμενος ΠΑ) και αντικαθιστούμε το p με αυτόν τον αριθμό.</p>";
	html+="<p class='algoStep' id='step5'><b>5.</b> Επαναλαμβάνουμε τα βήματα 3 και 4 με την προϋπόθεση ότι το p<sup>2</sup> είναι μικρότερο του n.</p>";
	html+="<p class='algoStep' id='step6'><b>6.</b> Οι αριθμοί που δεν έχουν διαγραφεί από τη λίστα είναι οι ΠΑ από 2 μέχρι n.</p>";
	html+="Προσπάθησε να συμπληρώσεις τις εντολές που υλοποιούν τον αλγόριθμο αυτό.";
	return html;
}

function showButtonCaptions(){
	if(buttonCaptionsVisible){
        $("#btnCheckCode").html("Υποβολή");
        $("#btnShowSolution").html("Λύση");
        $("#btnInitialiseCode").html("Επαναφορά");
        $("#btnPlay").html("Έναρξη");
        $("#btnStop").html("Αρχικοποίηση");
        $("#btnPause").html("Παύση");
        $("#btnContinue").html("Συνέχεια");
        $("#btnForward").html("Επόμενο");
        $("#btnOptions").html("Ρυθμίσεις");
        $(".btnMenu").css({"width":"175px"});
        $(".buttonData").width(160);
 	}
	else{
        $("#btnCheckCode").html("");
        $("#btnShowSolution").html("");
        $("#btnInitialiseCode").html("");
        $("#btnPlay").html("");
        $("#btnStop").html("");
        $("#btnPause").html("");
        $("#btnContinue").html("");
        $("#btnForward").html("");
        $("#btnOptions").html("");
        $(".btnMenu").css({"width":"30px"});
        $(".buttonData").width(40);
    }
	placeContents();
}

function showPrompt(){
	var msg="";
	switch(promptID){
	case promptToFillInBlanks:
		msg="Προσπάθησε να λύσεις το πρόβλημα συμπληρώνοντας ορθά τα κενά των εντολών που βλέπεις.";
        msg+="<br>Αν δυσκολεύεσαι, ίσως σε βοηθήσει η προβολή αντιστοιχίας μεταξύ του <i>Ελεύθερου Κειμένου</i> και της <i>Ψευδογλώσσας</i> μέσω των Ρυθμίσεων.";
		msg+="<br>Μπορείς να ελέγξεις την άποψή σου με το κουμπί [Υποβολή], ή να δεις την πλήρη εκδοχή του προγράμματος με το κουμπί [Λύση].";
		break;
	case promptToRunCode:
		msg="Αν θεωρείς τη λύση ολοκληρωμένη, 'τρέξε' το πρόγραμμά σου με το κουμπί [Έναρξη].";
        msg+=" Επιλέγοντας μία εντολή, μπορείς να προσθέσεις Σημείο Διακοπής (Breakpoint).";
		msg+="<br>Εναλλακτικά, δοκίμασε τη βηματική εκτέλεση με το κουμπί [Επόμενο].";
        msg+="<br>Χρησιμοποίησε τις Ρυθμίσεις Προσομοίωσης για να προβάλλεις πρόσθετες πληροφορίες υπό μορφή επεξηγήσεων.";
		break;
	case promptDuringRunning:
	    if($("#btnContinue").is(":visible")){
	        msg="Χρησιμοποίησε το κουμπί [Επόμενο] για να εκτελεστεί η επόμενη εντολή.";
	        msg+="<br>Χρησιμοποίησε το κουμπί [Συνέχεια] για να επιστρέψεις στην αυτόματη εκτέλεση.";
	    }
	    else{
	        msg="Χρησιμοποίησε το κουμπί [Παύση] για να διακόψεις την αυτόματη εκτέλεση.";
	    }
        msg+="<br>Χρησιμοποίησε το κουμπί [Αρχικοποίηση] για να τερματίσεις την αυτόματη εκτέλεση.";
		break;
	case promptAtEndOfRun:
	    msg="Χρησιμοποίησε το κουμπί [Αρχικοποίηση] για να διαγράψεις τα αποτελέσματα της εκτέλεσης του προγράμματος.";
	    msg+="<br>Άγγιξε ένα στοιχείο του πίνακα Λ για να δεις περισσότερες πληροφορίες.";
	    break;
	case promptSubmittedSolution:
		if(errorsFound){
			msg="Η εκδοχή που προτείνεις δεν είναι σωστή.";
			msg+="<br>Μελέτησε προσεκτικότερα την εκφώνηση του προβλήματος, προσπαθώντας να βρεις τις αντιστοιχίες των φράσεων του <i>Ελεύθερου Κειμένου</i> με τις εντολές της <i>Ψευδογλώσσας</i>.";
			msg+="<br>Μπορείς να κάνεις ορατές τις αντιστοιχείς αυτές μέσω των Ρυθμίσεων.";
		}
		else{
            if(solutionType==userSolution){
                msg="Πράγματι βρήκες μία λύση του προβλήματος.";
            }
            else{
                msg="Αυτή που βλέπεις είναι μία λύση του προβλήματος.";
            }
            msg+="<br>'Τρέξε' τώρα το πρόγραμμά σου για να εντοπίσεις Πρώτους αριθμούς.";
		}
		break;
	}
    $("#prompt").html(msg);
}

function showSolution(){
    var selectedPart="";
	if(requestConfirmationState || confirm("Θέλεις σίγουρα να αποκαλύψεις μία λύση;")){
		for(var i=0;i<noOfEntries;i++){
			if(Array.isArray(officialEntries[i])){
			    var j=parseInt(Math.random()*officialEntries[i].length);
			    selectedPart=officialEntries[i][j];
			}
			else{
			    selectedPart=officialEntries[i];
			}
		    $("#usrEntr"+i).html(selectedPart);
		}
		solutionType=officialSolution;
		promptID=promptSubmittedSolution;
		showPrompt();
	}
}

function checkCode(){
	var solutionOK=true;
	var j=0;
	var submitted;
	var official;
	while(j<noOfEntries && solutionOK){
	    submitted=trimSpaces(document.getElementById("usrEntr"+j).textContent.toLowerCase());
		if(Array.isArray(officialEntries[j])){
		    solutionOK=checkAgainstArray(submitted,j);
		}
		else{
		    official=trimSpaces(officialEntries[j].toLowerCase());
	        if(submitted!=official)solutionOK=false;
		}
		j++;
	}
	if(solutionOK){
		errorsFound=false;
		if(debugMode)alert("Πολύ σωστά!");
	}
	else{
		errorsFound=true;
		if(debugMode)alert("Υπάρχουν λάθη...");
	}
	promptID=promptSubmittedSolution;
	showPrompt();
	enableCodeSimulation();
}

function checkAgainstArray(submitted,j){
    var result=false;
    var official="";
    var i=0;
    while(!result && i<officialEntries[j].length){
        official=trimSpaces(officialEntries[j][i].toLowerCase());
        result=result || (submitted==official);
        i++;
    }
    return result;
}

function enableCodeSimulation(){
	$("#simulateControls").show(animationRate);
	$("#dataInput").show(animationRate);
}

function simulateCode(simulationSwitch){
	if(simulationSwitch){
		//έναρξη προσομοίωσης με κλήση timer
		timerLoop=setInterval(function(){simulateRun();},simSpeed);
	}
	else{
		clearInterval(timerLoop);
		simulating=false;
		$("#btnContinue").hide();
		$("#btnForward").hide();
    	$("#btnPlay").hide();
    	$("#btnPause").prop("disabled",true);
    	$("#btnStop").show();
    	$("#showOptions").show();
	}	
}

function simulateRun(){
	var entryResult;
	var jStart=0;
	simulationIndex++;
	var nxtSimulationIndex=simulationIndex;
	var cmdSimulated="cmd"+simulationIndex;
	if(showComments) showCurrentComment(cmdSimulated);
	if($("#"+cmdSimulated).hasClass("breakPointCmd")){
		$("#btnPause").click();//Παύση σε breakpoint
	}
	handleContinuationButtons();
	
	$(".simulatingCode").removeClass("simulatingCode");
	if(hideSimulationPath){
		jStart=simulationIndex;
	}
	//εμφάνιση μονοπατιού προσομοίωσης
	for(var j=jStart;j<=simulationIndex;j++){
		$("#cmd"+j).addClass("simulatingCode");
	}
	
	//Προσομοίωση αλγόριθμου
	switch(cmdSimulated){
	case Loop1Start:
		if(iInitialised){
			if(iSim>n){
				nxtSimulationIndex=parseInt(pInit.substr(3,2))-1;
			}
		}
		else{
			iInitialised=true;
			entryResult=stringExpressionValue($("#usrEntr0").text(),varNames,varValues);
			if(entryResult=="error"){
				abortSimulation();
				return;
			}
			else{
				iSim=entryResult;
				varValues[1]=iSim;
			}
		}
		break;
	case Loop1Body:
		updatePrimesArray(iSim,1);
		handleArray(0);
		break;
	case Loop1End:
		iSim++;
		varValues[1]=iSim;
		makeVisible(iSim,dontForceArrayDraw);
		nxtSimulationIndex=parseInt(Loop1Start.substr(3,2))-1;
		break;
	case pInit:
		entryResult=stringExpressionValue($("#usrEntr1").text(),varNames,varValues);
		if(entryResult=="error"){
			abortSimulation();
			return;
		}
		else{
			pSim=entryResult;
			varValues[2]=pSim;
			varValues[4]=primes[pSim]==1;
			setColorOfPrime();
			makeVisible(pSim,forceArrayDraw);
		}
		break;
	case while1Start:
		entryResult=stringLogicalValue($("#usrEntr2").text(),varNames,varValues);
		if(entryResult=="error"){
			abortSimulation();
			return;
		}
		else{
			if(!entryResult) nxtSimulationIndex=parseInt(while1End.substr(3,2));
		}
		break;
	case multInit:
		entryResult=stringExpressionValue($("#usrEntr3").text(),varNames,varValues);
		if(entryResult=="error"){
			abortSimulation();
			return;
		}
		else{
			zSim=entryResult;
			varValues[3]=zSim;
		}
		break;
	case while2Start:
		entryResult=stringLogicalValue($("#usrEntr4").text(),varNames,varValues);
		if(entryResult=="error"){
			abortSimulation();
			return;
		}
		else{
			if(!entryResult){
				nxtSimulationIndex=parseInt(while2End.substr(3,2));
			}
			else{
				makeVisible(zSim*pSim,dontForceArrayDraw);
			}
		}
		break;
	case while2Body1:
		updatePrimesArray(zSim*pSim,0);
		exclColors[zSim*pSim].push(excludingColor[maxColorSlctd]);
		handleArray(0);
		break;
	case while2Body2:
		entryResult=stringExpressionValue($("#usrEntr5").text(),varNames,varValues);
		if(entryResult=="error"){
			abortSimulation();
			return;
		}
		else{
			zSim+=entryResult;
			varValues[3]=zSim;
		}
		break;
	case while2End:
		nxtSimulationIndex=parseInt(while2Start.substr(3,2))-1;
		break;
	case repeatStart:
		//μην κάνεις τίποτε
		break;
	case repeatBody:
		entryResult=stringExpressionValue($("#usrEntr6").text(),varNames,varValues);
		if(entryResult=="error"){
			abortSimulation();
			return;
		}
		else{
			pSim++;
			varValues[2]=pSim;
			makeVisible(pSim,forceArrayDraw);
		}
		break;
	case repeatEnd:
		entryResult=stringLogicalValue($("#usrEntr7").text(),varNames,varValues);
		if(entryResult=="error"){
			abortSimulation();
			return;
		}
		else{
			if(!entryResult){
				nxtSimulationIndex=parseInt(repeatStart.substr(3,2));
			}
			else{
				setColorOfPrime();
				handleArray(0);
			}
		}
		break;
	case while1End:
		nxtSimulationIndex=parseInt(while1Start.substr(3,2))-1;
		break;
	}

	showSimulationValues();
	if(simulationIndex>parseInt(while1End.substr(3,2))){//Μετά την προσομοίωση της τελευταίας εντολής τερμάτισε το μηχανισμό προσομοίωσης
		simulateCode(false);
		promptID=promptAtEndOfRun;
	}
	simulationIndex=nxtSimulationIndex;
	showPrompt();
}

function showCurrentComment(cmdSimulated){
	var comment="";
	switch(cmdSimulated){
	case eisodos1:
	    comment="Προτρεπτικό μήνυμα για εισαγωγή πλήθους ελεγχόμενων αριθμών.";
	    break;
	case eisodos2:
		comment="Εισαγωγή τιμής του <span class='suggestedName'>n</span>.";
	    break;
	case Loop1Start:
	    if(iInitialised){
            comment="Σύγκριση της νέας τιμής της μεταβλητής <span class='suggestedName'>i</span> με την <span class='suggestedName'>n</span>.";    
    	}
	    else{
            comment="Δομή επανάληψης για σάρωση όλων των θέσεων της λίστας μέχρι τη θέση <span class='suggestedName'>n</span>.";
	    }
        break;
	case Loop1Body:
		comment="Αρχικά όλοι οι αριθμοί θεωρούνται Πρώτοι.";
		break;
	case Loop1End:
		comment="Μεταβολή της <span class='suggestedName'>i</span> κατά 1";
		break;
	case pInit:
		comment="Αρχικοποίηση της μεταβλητής <span class='suggestedName'>p</span>";
		break;
	case while1Start:
		comment="Ελέγχουμε αν έχει νόημα να συνεχίσουμε να αναζητούμε μη Πρώτους Αριθμούς.";
		break;
	case multInit:
		comment="Αρχικοποίηση του πολλαπλασιαστή <span class='suggestedName'>z</span>.";
		break;
	case while2Start:
		comment="Έλεγχος παραμονής εντός ορίων του πίνακα <span class='suggestedName'>Λ</span>.";
		break;
	case while2Body1:
		comment="Διαγραφή τιμής που είναι πολλαπλάσιο του τρέχοντος Πρώτου.";
		break;
	case while2Body2:
		comment="Επόμενη τιμή πολλαπλασιαστή.";
		break;
	case while2End:
		comment="Ολοκλήρωση τρέχουσας επανάληψης. Μεταφορά στην αρχή της Δομής για επανέλεγχο της συνθήκης.";
		break;
	case repeatStart:
		comment="Οριοθέτηση της Δομής Επανάληψης.";
		break;
	case repeatBody:
		comment="Αναζήτηση επόμενου Πρώτου Αριθμού στη λίστα...";
		break;
	case repeatEnd:
		comment="... μέχρι να εντοπιστεί αριθμός που δεν έχει διαγραφεί, <b>ή</b> να εξαντληθεί η λίστα.";
		break;
	case while1End:	
		comment="Ολοκλήρωση τρέχουσας επανάληψης της εξωτερικής ΟΣΟ</code>.";
		break;
	}
	$("#commentArea").html(comment);
}

function makeVisible(cellIndex,forceDrawFlag){
	var arrayNotDrawn=true;
	while(cellLeft(cellIndex,firstVisibleCell)>=canvas.width-cellSize){
		firstVisibleCell++;
		drawArray(firstVisibleCell);
		arrayNotDrawn=false;
	}
	while(cellLeft(cellIndex,firstVisibleCell)<=0){
		firstVisibleCell--;
		drawArray(firstVisibleCell);
		arrayNotDrawn=false;
	}
	if(forceDrawFlag && arrayNotDrawn) drawArray(firstVisibleCell);
}

function handleContinuationButtons(){
	if(simulating)return;
	if(simulationIndex>parseInt(while1End.substr(3,2))){
		$("#btnForward").prop("disabled",true);
	}
	else{
		$("#btnForward").prop("disabled",false);
	}
}

function clearSimulated(){
	$(".simulatingCode").removeClass("simulatingCode");
	$(".conditionTrue").removeClass("conditionTrue");
	$(".conditionFalse").removeClass("conditionFalse");
	$(".conditionInError").removeClass("conditionInError");
}

function resetSimulation(){
	resizeArray();
	resetErrorMessages();
	clearSimulated();
	iInitialised=false;
	simulationIndex=-1;
	handleContinuationButtons();
	showSimulationValues();
	$("#commentArea").html("");
}

function setColorOfPrime(){
	maxColorSlctd=(maxColorSlctd+1) % excludingColor.length;
	exclColors[pSim]=-maxColorSlctd;//Χρώμα ταυτοποίησης Πρώτου Αριθμού
}

function generateEntryPlaceholder(entryID,presetValue,editableState){
	var content="ˍˍˍ";
	var classToShow=(editableState)?"class='toChange'":"";
	if(presetValue!== undefined)content=presetValue;
	var newEntry="<span "+classToShow+" id='"+entryID+"' contenteditable='true'>"+content+"</span>";
	return newEntry;
}

function initialiseGraphics(){
    canvas=document.getElementById("visualisation");
    cntx=canvas.getContext("2d");
    //Πλάτος καμβά ίσο με το διαθέσιμο πλάτος προβολής
    cntx.canvas.width=window.innerWidth;
    initialiseArray();
}

function initialiseArray(){
	for(var i=0;i<=n;i++){
		primes.push(-1);
		exclColors.push([]);
	}
	handleArray(0);
}

function resizeArray(){
	primes=[];
	exclColors=[];
	maxColorSlctd=-1;
	iSim=0;
	iInitialised=false;
	pSim=0;
	multSim=0;
	initialiseArray();
}

function drawArray(startingCell){
	cntx.clearRect(0,0,canvas.width,canvas.height);
	var i;
	for(i=1;i<=n;i++){
		drawCell(i,startingCell-1);
	}
}

function drawCell(i,startingCell){
	var LeftCoord=cellLeft(i,startingCell);
	
	//Μη σχεδιάζεις κελιά εκτός ορατών ορίων
	if(LeftCoord<-cellSize || LeftCoord>canvas.width) return;
	
	//Εμφάνιση δείκτη
	cntx.textAlign="start";
	cntx.font="14px Georgia";
	if(i==pSim){
		cntx.fillStyle="#ff0000";
		cntx.font="bold 14px Georgia";
	}
	else{
		if(primes[i]==1){
			cntx.fillStyle="#000000";
		}
		else{
			cntx.font="12px Georgia";
			cntx.fillStyle="#8f8f8f";
		}
	}
	var indexLeft=parseInt(LeftCoord+(cellSize-cntx.measureText(""+i).width)/2);
	cntx.fillText(""+i,indexLeft,cellTop-5);

	//Σχεδίαση φόντου
	if(i>1){
		if(primes[i]==1){//Κελλί πρώτου αριθμού
			cntx.fillStyle="#ADD8E6";
			cntx.beginPath();
			cntx.rect(LeftCoord,cellTop,cellSize,cellSize);
			cntx.fill();
			if(i<=pSim){
				cntx.strokeStyle=excludingColor[-exclColors[i]];
				for(var j=1;j<exclClrBorder;j++){
					cntx.beginPath();
					cntx.rect(LeftCoord+j,cellTop+j,cellSize-2*j,cellSize-2*j);
					cntx.stroke();
				}
			}
		}
		else{//Κελλί μη πρώτου αριθμού
			if(exclColors[i]){
				var k=0;
				for(var j=0;j<=exclColors[i].length;j++){
					cntx.fillStyle=exclColors[i][j];
					cntx.beginPath();
					cntx.rect(LeftCoord+exclClrBorder*k,cellTop+exclClrBorder*k,cellSize-2*exclClrBorder*k,cellSize-2*exclClrBorder*k);
					cntx.fill();
					k++;
				}
			}
		}
	}

	//Σχεδίαση περιγράμματος
	cntx.strokeStyle="#00008B";
	cntx.beginPath();
	cntx.rect(LeftCoord,cellTop,cellSize,cellSize);
	cntx.stroke();

	//Εμφάνιση περιεχομένου
	if(i>1){
		var content="";
		if(primes[i]==1){
			content="Α";
			cntx.fillStyle="#00008B";
		}
		else if(primes[i]==0){
			content="Ψ";
			cntx.fillStyle="#8B0000";
		}
		cntx.font="20px Georgia";
		var contentLeft=(cellSize-cntx.measureText(content).width)/2+LeftCoord;
		cntx.fillText(content,contentLeft,cellTop+cellSize-(cellSize-20)/2);
	}
}

function cellLeft(i,startingCell){
	return (i-startingCell-1)*cellSize+cellSize/2;
}

function handleArray(step){
	firstVisibleCell+=step;
	handleNavigationButtons();
	drawArray(firstVisibleCell);
}

function handleNavigationButtons(){
	if(firstVisibleCell<=1){
		$("#btnNext").fadeTo(0,0.5);
		$("#btnLast").fadeTo(0,0.5);
		$("#btnPrevious").fadeTo(0,0);
		$("#btnFirst").fadeTo(0,0);
    	$("#btnPrevious").css({
    		"background-color" : "#ffffff",
    		"box-shadow" : "1px 1px #ffffff,2px 2px #ffffff,3px 3px #ffffff"
    	});
    	$("#btnFirst").css({
    		"background-color" : "#ffffff",
    		"box-shadow" : "1px 1px #ffffff,2px 2px #ffffff,3px 3px #ffffff"
    	});
		firstVisibleCell=1;
	}
	else if(firstVisibleCell>=n){
		$("#btnFirst").fadeTo(0,0.5);
		$("#btnPrevious").fadeTo(0,0.5);
		$("#btnNext").fadeTo(0,0);
    	$("#btnNext").css({
    		"background-color" : "#ffffff",
    		"box-shadow" : "1px 1px #ffffff,2px 2px #ffffff,3px 3px #ffffff"
    	});
		$("#btnLast").fadeTo(0,0);
    	$("#btnLast").css({
    		"background-color" : "#ffffff",
    		"box-shadow" : "1px 1px #ffffff,2px 2px #ffffff,3px 3px #ffffff"
    	});
		firstVisibleCell=n;
	}
	else{
		$("#btnFirst").fadeTo(0,0.5);
		$("#btnPrevious").fadeTo(0,0.5);
		$("#btnNext").fadeTo(0,0.5);
		$("#btnLast").fadeTo(0,0.5);
	}
}

function showSimulationValues(){
	if(!showVarValues) return;
	
	//τιμή του n
	if(simulationIndex>=parseInt(eisodos2.substr(3,2)) && simulationIndex<=parseInt(while1End.substr(3,2))){
		$("#nVal").html(" n="+n+" ");
		$("#nVal").show(animationRate);
	}
	else{
		$("#nVal").html("");
		$("#nVal").hide(animationRate);
	}
	
	//τιμή του i
	if(simulationIndex>=parseInt(Loop1Start.substr(3,2)) && simulationIndex<parseInt(pInit.substr(3,2))){
		var additional="";
		if(simulationIndex==parseInt(Loop1Start.substr(3,2))){
			var result=iSim<=n?"Α":"Ψ";
			additional=", (i<=n) = "+result+" ";
		}
		$("#iVal").html(" i="+iSim+" "+additional);
		$("#iVal").show(animationRate);
	}
	else{
		$("#iVal").html("");
		$("#iVal").hide(animationRate);
	}
	
	//τιμή του k
	if(pSim==2){
		$("#pInitVal").html(" p="+pSim+" ");
		$("#pInitVal").show(animationRate);
	}
	else{
		$("#pInitVal").html("");
		$("#pInitVal").hide(animationRate);
	}
	
	//Συνθήκη εξωτερικής ΟΣΟ
	if(simulationIndex==parseInt(while1Start.substr(3,2)) || simulationIndex>parseInt(while1End.substr(3,2))){
		var msg1=" ("+pSim+"^2<="+n+") = ";
		var msg2="Ψ";
		if(Math.pow(pSim,2)<=n){
			msg2="Α";
		}
		$("#while1CondVal").html(msg1+msg2+" ");
		$("#while1CondVal").show(animationRate);
	}
	else{
		$("#while1CondVal").html("");
		$("#while1CondVal").hide(animationRate);
	}
	
	//τιμή του z
	if(zSim==2){
		$("#zInitVal").html(" z="+zSim+" ");
		$("#zInitVal").show(animationRate);
	}
	else{
		$("#zInitVal").html("");
		$("#zInitVal").hide(animationRate);
	}
	
	//Συνθήκη εσωτερικής ΟΣΟ
	if(simulationIndex==parseInt(while2Start.substr(3,2))){
		var result=pSim*zSim<=n?"Α":"Ψ";
		$("#while2CondVal").html(" ("+zSim+"*"+pSim+"<="+n+") =  "+result+" ");
		$("#while2CondVal").show(animationRate);
	}
	else{
		$("#while2CondVal").html("");
		$("#while2CondVal").hide(animationRate);
	}
	
	//Εμφάνιση γινομένου k*z
	if(simulationIndex==parseInt(while2Body1.substr(3,2))){
		$("#pzVal").html(" z*p="+zSim+"*"+pSim+"="+pSim*zSim+" ");
		$("#pzVal").show(animationRate);
	}
	else{
		$("#pzVal").html("");
		$("#pzVal").hide(animationRate);
	}
	
	//Μεταβολή του z
	if(simulationIndex==parseInt(while2Body2.substr(3,2))){
		$("#zVal").html(" z="+zSim+" ");
		$("#zVal").show(animationRate);
	}
	else{
		$("#zVal").html("");
		$("#zVal").hide(animationRate);
	}
	
	//Μεταβολή του k
	if(simulationIndex>=parseInt(repeatBody.substr(3,2)) && simulationIndex<=parseInt(repeatEnd.substr(3,2))){
		$("#pVal").html(" p="+pSim+" ");
		$("#pVal").show(animationRate);
	}
	else{
		$("#pVal").html("");
		$("#pVal").hide(animationRate);
	}
	
	//Συνθήκη ΜΕΧΡΙΣ_ΟΤΟΥ
	if(simulationIndex==parseInt(repeatEnd.substr(3,2))){
		var cellContent=primes[pSim]==1?"Α":"Ψ";
		var cond2=pSim==n?"Α":"Ψ";
		var result=(primes[pSim]==1 || pSim==n)?"Α":"Ψ";
		var msg=" ("+cellContent+" Ή "+cond2+") = ";
		$("#repeatCondVal").html(msg+result+" ");
		$("#repeatCondVal").show(animationRate);
	}
	else{
		$("#repeatCondVal").html("");
		$("#repeatCondVal").hide(animationRate);
	}
}

function saveUserEntry(entryID){
    
	entryIndex=parseInt(entryID.substr("usrEntr".length,2));
	//userEntries[entryIndex]=trimSpaces($("#"+entryID).html());
	userEntries[entryIndex]=$("#"+entryID).html();
    solutionType=userSolution;
    countEntries();
}

function countEntries(){
    var filledEntries=0;
    for(var i=0;i<userEntries.length;i++){
        if(userEntries[i]!=null && userEntries[i]!="")filledEntries++;
    }
    if(filledEntries==noOfEntries){
        //$("#solutionControls").show(animationRate); //Τα controls είναι ήδη ορατά από εκπαιδευτική άποψη
        promptID=promptToRunCode;
    }
    else{
        promptID=promptToFillInBlanks;
    }
    showPrompt();
}

function abortSimulation(){
    simulationAborted=true;
	$("#btnStop").click();
}

function updatePrimesArray(i,newValue){
	primes[i]=newValue;
	varValues[4]=primes;
}

function getNoInfo(slctdNo){
	var c=0;
	var i=2;
	var dividers="";
	var result="";
	while(i<slctdNo && Math.pow(i,2)<=n){
		if(slctdNo % i == 0){
			c++;
			if(c>1)dividers+=", ";
			dividers+=i;
		}
		do{
			if(i==2){
				i=3;
			}
			else{
				i+=2;	
			}
		}while(primes[i]==0);
	}
	if(c==0){
		result="Πρώτος αριθμός.";
	}
	else{
		result="Ο αριθμός δεν είναι Πρώτος: Εντοπίστηκαν οι Πρώτοι παράγοντες {"+dividers+"}";
	}
	return result;
}

function showMatches(index){
    switch(index){
    case 1:
        for(var i=2;i<5;i++){
            $("#cmd"+i).addClass("matched");
        }
        break;
    case 2:
        $("#cmd5").addClass("matched");
        break;
    case 3:
        for(var i=8;i<12;i++){
            $("#cmd"+i).addClass("matched");
        }
        break;
    case 4:
        for(var i=12;i<15;i++){
            $("#cmd"+i).addClass("matched");
        }
        break;
    case 5:
        $("#cmd6").addClass("matched");
        $("#cmd15").addClass("matched");
        break;
    case 6:
        //καμμία αντιστοιχία
        break;
    }    
}